"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var src_exports = {};
__export(src_exports, {
  normalizeExports: () => normalizeExports
});
module.exports = __toCommonJS(src_exports);
var import_node_fs = require("node:fs");
var import_node_path = __toESM(require("node:path"));
var import_picomatch = __toESM(require("picomatch"));
const defaultConditions = ["node", "import", "default"];
const checkExportsConfiguration = (exports) => {
  if (typeof exports === "object") {
    if (Object.keys(exports).length === 0) {
      throw new Error("No entries found in exports map");
    }
    if (!Array.isArray(exports)) {
      const exportsKeys = Object.keys(exports);
      const keysStartingWithPeriod = exportsKeys.filter((key) => key.startsWith("."));
      if (keysStartingWithPeriod.length !== 0 && keysStartingWithPeriod.length !== exportsKeys.length) {
        throw new Error("Invalid exports configuration");
      }
    }
  }
};
const matchConditions = (exports, conditions) => {
  if (Array.isArray(exports)) {
    if (exports.length === 0) {
      return null;
    }
    let lastError;
    for (const subEntry of exports) {
      try {
        const value = matchConditions(subEntry, conditions);
        if (typeof value !== "undefined") {
          return value;
        }
      } catch (error) {
        lastError = error;
      }
    }
    if (typeof lastError === "object") {
      throw lastError;
    }
  } else if (exports && typeof exports === "object") {
    for (const [key, subEntry] of Object.entries(exports)) {
      if (conditions.has(key)) {
        const value = matchConditions(subEntry, conditions);
        if (typeof value !== "undefined") {
          return value;
        }
      }
    }
  } else if (typeof exports === "string" && !exports.startsWith("./")) {
    throw new Error(`Invalid target '${exports}'`);
  } else {
    return exports;
  }
};
const expandWildcardEntry = (key, value, cwd) => {
  const expr = import_picomatch.default.makeRe(value, {
    capture: true,
    noglobstar: true
  });
  const directoryName = import_node_path.default.dirname(value);
  const directoryFullPath = import_node_path.default.join(cwd, directoryName);
  const expandedWildcardEntries = {};
  if ((0, import_node_fs.existsSync)(directoryFullPath)) {
    const fileNames = (0, import_node_fs.readdirSync)(directoryFullPath).filter(
      (filePath) => (0, import_node_fs.statSync)(import_node_path.default.join(directoryFullPath, filePath)).isFile()
    );
    for (const fileName of fileNames) {
      const relativeFilePath = import_node_path.default.join(directoryName, fileName);
      const match = expr.exec(relativeFilePath);
      if (match?.[1]) {
        const [matchingPath, matchGroup] = match;
        const normalizedKey = key.replace("*", matchGroup);
        const normalizedFilePath = `./${matchingPath}`;
        expandedWildcardEntries[normalizedKey] = normalizedFilePath;
      }
    }
  } else {
    throw new Error(`Directory '${directoryFullPath}' not found`);
  }
  return expandedWildcardEntries;
};
const getFlattenedEntries = (exports, conditions, cwd) => {
  let flattenedEntries = {};
  const singleSubpath = matchConditions(exports, conditions);
  if (typeof singleSubpath === "string") {
    flattenedEntries["."] = singleSubpath;
  } else {
    for (const [key, subEntry] of Object.entries(exports)) {
      if (!key.startsWith(".")) {
        continue;
      }
      const value = matchConditions(subEntry, conditions);
      if (typeof value !== "string") {
        continue;
      }
      if (key.includes("*") && cwd) {
        flattenedEntries = {
          ...flattenedEntries,
          ...expandWildcardEntry(key, value, cwd)
        };
      } else {
        flattenedEntries[key] = value;
      }
    }
  }
  return flattenedEntries;
};
const normalizeExports = (exports, options) => {
  if (!exports) {
    throw new Error("Exports is not defined");
  }
  checkExportsConfiguration(exports);
  const conditions = /* @__PURE__ */ new Set([...defaultConditions, ...options?.conditions || []]);
  const cwd = options?.cwd;
  const normalizedExports = getFlattenedEntries(exports, conditions, cwd);
  return normalizedExports;
};
